//+------------------------------------------------------------------+
//|                                                     ktlamb84.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property link      "http://www.forex-tsd.com"
extern double takeProfitPips = 40;
extern double stopLossPips = 200;
double slippage = 0;
double lots = 1.0;
double magic_number = 00084000001;
double newPoint;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
	if (StringFind(Symbol(),"JPY") >=0 ) {
		newPoint =  0.01;
	} else {
		newPoint = 0.0001;
	}   	   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double rsi = iRSI(Symbol(),0,14,PRICE_TYPICAL,0);
   double ema_50 = iMA(Symbol(),0,50,0,MODE_EMA,PRICE_OPEN,0);
   double ema_50_past = iMA(Symbol(),0,50,0,MODE_EMA,PRICE_OPEN,1);
   double ema_10 = iMA(Symbol(),0,10,0,MODE_EMA,PRICE_OPEN,0);
   double ema_10_past = iMA(Symbol(),0,10,0,MODE_EMA,PRICE_OPEN,1);
   double ema_15 = iMA(Symbol(),0,15,0,MODE_EMA,PRICE_OPEN,0);
   double ema_15_past = iMA(Symbol(),0,15,0,MODE_EMA,PRICE_OPEN,1);
/*
The EA is based on the 10 EMA crossing above the 50 EMA when the RSI is >= 65 and 
   closing when the 10 EMA crosses below the 15 EMA or 
*/
   if (((ema_10>ema_50)&&(ema_10_past<=ema_50_past))
       &&(rsi >= 65)) doEnter(OP_SELL);
/*
when the 10 EMA crosses below the 50 EMA and when the RSI is <= 35 
   and closing when the 10 EMA crosses above the 15 EMA. 
*/
   else if (((ema_10<ema_50)&&(ema_10_past>=ema_50_past))
            &&(rsi <= 35)) doEnter(OP_BUY);      
/*
  Closing bits
  
*/           
   if (((ema_10<ema_15)&&(ema_10_past==ema_15_past))
      ||((ema_10>ema_15)&&(ema_10_past==ema_15_past))) doClose();
   return(0);
  }
//+------------------------------------------------------------------+

void doEnter(int cmd) {
  int i;
  double usePrice,stopLoss,takeProfit;
  int totalTrades = OrdersTotal();
  for (i=0;i<totalTrades;i++) if (OrderSelect(i,SELECT_BY_POS) == true && OrderSymbol() == Symbol() && OrderMagicNumber() == magic_number) return;
  if ( cmd == OP_BUY ) { usePrice = Ask; if (takeProfitPips > 0) takeProfit = Ask + takeProfitPips * newPoint; if (stopLossPips > 0) stopLoss = Bid - stopLossPips * newPoint; }
  else if ( cmd == OP_SELL ) { usePrice = Bid; if (takeProfitPips > 0) takeProfit = Bid - takeProfitPips * newPoint; if (stopLossPips > 0) stopLoss = Ask + stopLossPips * newPoint; }
  OrderSend(Symbol(),cmd,lots,usePrice,slippage,stopLoss,takeProfit,"ktlamb84",magic_number,0,Green);  
}

void doClose() {
  int i;
  int totalTrades = OrdersTotal();
  for (i=0;i<totalTrades;i++) {
    if (OrderSelect(i,SELECT_BY_POS) == true && OrderSymbol() == Symbol() && OrderMagicNumber() == magic_number)
    {
      if (OrderType() == OP_SELL) {
        OrderClose(OrderTicket(),OrderLots(),Ask,0);
      } else if (OrderType() == OP_BUY) {
        OrderClose(OrderTicket(),OrderLots(),Bid,0);
      }      
    }    
  }
}